#!/usr/bin/php
<?php
// Copyright (C) 2005 Claus Lund, clauslund@gmail.com
echo "\nStarting to reload cache\n";
echo date("Y-m-d H:i:s")."\n\n";
$APP_ROOT = '/var/www/html';

include_once "$APP_ROOT/includes/adodb/adodb.inc.php";
include_once "$APP_ROOT/includes/common_funcs.php";
include_once "$APP_ROOT/config/config.php";

$dbLink = db_connect_syslog(DBUSER, DBUSERPW);

// If merge table exists and is not empty
// then load the cache with data from that table
$mergelog = FALSE;
if(table_exists(MERGELOGTABLE, $dbLink)) {
	$sql = "SELECT * FROM ".MERGELOGTABLE." LIMIT 1";
	$result = perform_query($sql, $dbLink);
	if(num_rows($result)) {
		$mergelog = TRUE;
	}
}

if($mergelog) {
	echo "Loading the cache with data from the merge table\n";
	reload_cache(MERGELOGTABLE, $dbLink);
}
// Else load the cache with data from each log table
else {
	$tableArray = get_logtables($dbLink);
	foreach($tableArray as $table) {
		echo "Loading the cache with data from: ".$table."\n";
		reload_cache($table, $dbLink);
	}
}

// Delete rows with data from log tables that do not exist
echo "\nDeleting cache entries for tables that no longer exist...\n";
$tableArray = get_logtables($dbLink);

$sql = "SELECT DISTINCT tablename FROM ".CACHETABLENAME;
$result = perform_query($sql, $dbLink);
while($row = $result->FetchRow()) {
	if(array_search($row['tablename'], $tableArray) === FALSE) {
		$sql = "DELETE FROM ".CACHETABLENAME." WHERE tablename='".$row['tablename']."'";
		perform_query($sql, $dbLink);
	}
}

if($mergelog) {
	$sql = "DELETE FROM ".CACHETABLENAME." WHERE tablename!='".MERGELOGTABLE."'";
	perform_query($sql, $dbLink);
}

echo "\n".date("Y-m-d H:i:s")."\n";
echo "All done!\n";
?>
